<!--
 * @Descripttion:
 * @version:
 * @Author: kBank
 * @Date: 2022-10-24 15:45:01
-->
<template>
  <div class="page">
    <topBar
      v-if="topList.length > 0"
      :top-list="topList"
      :moren="moren"
    />
    <div class="main">
      <el-form
        ref="select"
        :model="select"
        style="padding:0px 10px 0 0;background: #fff"
        label-width="100px"
      >
        <el-row>
          <!-- 一层 -->
          <el-col :span="4">
            <el-form-item label="奖金期数">
              <div style="display: flex">
                <div>
                  <el-input v-model="select.period" clearable />
                </div>
              </div>
            </el-form-item>
          </el-col>

          <el-collapse-transition>
            <div v-show="isActive">
              <el-col :span="4">
                <el-form-item :label="'重算状态'">
                  <el-select
                    v-model="select.isRetry"
                    clearable
                    placeholder=""
                  >
                    <el-option
                      v-for="item in dealerList"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="4">
                <el-form-item :label="'公布状态'">
                  <el-select
                    v-model="select.isPublish"
                    clearable
                    placeholder=""
                  >
                    <el-option
                      v-for="item in dealerList"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="4">
                <el-form-item :label="'发放状态'">
                  <el-select
                    v-model="select.isGrant"
                    clearable
                    placeholder=""
                  >
                    <el-option
                      v-for="item in dealerList"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    />
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="4">
                <el-form-item :label="'提现状态'">
                  <el-select
                    v-model="select.isWithdrawal"
                    clearable
                    placeholder=""
                  >
                    <el-option
                      v-for="item in dealerList"
                      :key="item.value"
                      :label="item.label"
                      :value="item.value"
                    />
                  </el-select>
                </el-form-item>
              </el-col>

              <div>
                <el-col :span="8">
                  <el-form-item :label="'结算日期'">
                    <el-date-picker
                      v-model="creationTime"
                      value-format="yyyy-MM-dd"
                      type="datetimerange"
                      :range-separator="'至'"
                      :start-placeholder="'开始日期'"
                      :end-placeholder="'结束日期'"
                      format="yyyy-MM-dd"
                      @change="changeTime"
                    />
                  </el-form-item>
                </el-col>
                <el-col :span="4" style="margin-left: 40px;margin-top: 3px">
                  <el-button
                    class="my_search"
                    type="primary"
                    @click="getDataList"
                  > {{ '搜索' }}</el-button>
                  <el-button
                    class="my_reset"
                    @click="reset"
                  > {{ '重置' }}</el-button>
                </el-col>
              </div>
            </div>
          </el-collapse-transition>

        </el-row>

      </el-form>
      <div class="maintop">
        <div class="mainbtn">
          <el-button
            v-has-buttons="['bonusCountSettlement']"
            size="small"
            style="background-color: #48B2FD;"
            class="thebtn2"
            :loading="operatorLoading"
            @click="balance"
          >{{ '结算' }}</el-button>
          <el-button
            v-has-buttons="['bonusCountPublish']"
            size="small"
            class="thebtn2"
            :loading="operatorLoading"
            @click="publish"
          >{{ '公布' }}</el-button>
          <el-button
            size="small"
            class="thebtn2"
            :loading="operatorLoading"
            @click="publish1"
          >{{ '不公布' }}</el-button>
          <el-button
            v-has-buttons="['bonusCountGrant']"
            size="small"
            style="background-color: #009B58"
            class="thebtn2"
            :loading="operatorLoading"
            @click="grant"
          >{{ '发放' }}</el-button>
          <el-button
            v-has-buttons="['bonusCountCash']"
            size="small"
            style="background-color: #48B2FD"
            class="thebtn2"
            :loading="operatorLoading"
            @click="withdraw"
          >{{ '提现' }}</el-button>
        </div>
        <div>
          <el-dropdown :hide-on-click="false">
            <span class="el-dropdown-link kuang">
              {{ '筛选字段' }}<i class="el-icon-arrow-down el-icon--right" />
            </span>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item
                v-for="item in menuList"
                :key="item.id"
              >
                <el-checkbox
                  v-model="item.checked"
                  @change="getMenu($event,item.id)"
                >{{ item.text }}</el-checkbox></el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </div>
      </div>
      <div class="maintable">
        <div class="itemTrading">
          <el-table
            ref="multipleTable"
            v-loading="loading"
            height="690px"
            class="content"
            :data="tableData.censusSummaryList"
            style="width: 100%;"
            :header-cell-style="{ background: '#EEEEEE' }"
            :row-class-name="tableRowClassName"
            :summary-method="getSummaries"
            @selection-change="handleSelectionChange"
          >
            <el-table-column type="selection" />
            <el-table-column
              align="center"
              prop="pkId"
              width="130"
              :label="'奖金期数'"
            />
            <el-table-column
              align="center"
              prop="settleDate"
              width="130"
              :label="'结算日期'"
            />
            <el-table-column
              v-if="menuList[1].checked==true"
              align="center"
              prop="orderCode"
              width="130"
              :label="'首购金额'+`(${isLocalSymbol()})`"
              :formatter="stateFormat"
            />
            <el-table-column
              align="center"
              prop="orderTypeVal"
              width="130"
              :label="'首购拨比'+'(%)'"
            />
            <el-table-column
              v-if="menuList[2].checked==true"
              align="center"
              prop="sourceCountryName"
              width="130"
              :label="'复购金额'+`(${isLocalSymbol()})`"
              :formatter="stateFormat"
            />
            <el-table-column
              align="center"
              prop="sourceMemberCode"
              width="130"
              :label="'复购拨比'+'(%)'"
            />
            <el-table-column
              v-if="menuList[3].checked==true"
              align="center"
              prop="sourceMemberName"
              width="130"
              :label="'当月首购金额'+`(${isLocalSymbol()})`"
              :formatter="stateFormat"
            />
            <el-table-column
              align="center"
              prop="firstBuyAmount"
              width="130"
              :label="'当月首购拨比'+'(%)'"
            />
            <el-table-column
              v-if="menuList[4].checked==true"
              align="center"
              prop="firstBuyAmount"
              width="130"
              :label="'当月复购金额'+`(${isLocalSymbol()})`"
              :formatter="stateFormat"
            />
            <el-table-column
              align="center"
              prop="firstBuyAmount"
              width="130"
              :label="'当月复购拨比'+'(%)'"
              :formatter="stateFormat"
            />
            <el-table-column
              align="center"
              prop="isSettleVal"
              width="100"
              :label="'重算状态'"
            />
            <el-table-column
              align="center"
              prop="settleDate"
              width="100"
              :label="'重算日期'"
            />
            <el-table-column
              align="center"
              prop="isPublishVal"
              width="100"
              :label="'公布状态'"
            />
            <el-table-column
              align="center"
              prop="isGrantVal"
              width="100"
              :label="'发放状态'"
            />
            <el-table-column
              align="center"
              prop="grantDate"
              width="130"
              :label="'发放日期'"
            />
            <el-table-column
              align="center"
              prop="isWithdrawalVal"
              width="130"
              :label="'提现状态'"
            />
            <el-table-column
              align="center"
              prop="withdrawalDate"
              width="130"
              :label="'创建日期'"
            />
            <el-table-column
              width="auto"
              label=""
            />
          </el-table>
        </div>
      </div>
    </div>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getDataList"
    />

  </div>
</template>

<script>
import topBar from '@/components/topBar'
import * as api from '@/api/settle.js'
import { classifyUpdate, classifySave } from '@/api/product'
import * as log from '@/api/logistics'
import { settleBonus, publishBonus, grantBonus, withdrawalBonus, noPublishBonus } from '@/api/member'
import { listPeriod } from '@/api/bonus'
import { Message } from 'element-ui'
import { isLocal, isLocalSymbol, stateFormat } from '@/utils/numberToCurrency'
import { mapGetters } from 'vuex'
export default {
  name: 'Bzpz',
  components: {
    topBar
  },
  filters: {
    isAgree(val) {
      if (!val) {
        return '允许'
      } else {
        return '禁止'
      }
    }
  },
  data() {
    return {
      dealerList: [],
      isActive: true,
      typeList: [
        {
          value: 0,
          label: '前台'
        },
        {
          value: 1,
          label: '后台'
        }
      ],
      digList: [
        {
          value: 0,
          label: '允许'
        },
        {
          value: 1,
          label: '禁止'
        }
      ],
      menuList: [
        {
          id: 0,
          text: '全选',
          checked: true
        },
        {
          id: 1,
          checked: true,
          prop: 'firstBuyAmountDollar',
          text: `${'首购金额'}(${isLocalSymbol()})`
        },
        {
          id: 2,
          text: `${'复购金额'}(${isLocalSymbol()})`,
          checked: true,
          prop: 'upgradeAmountDollar'
        },
        {
          id: 3,
          text: `${'首购金额'}(${isLocalSymbol()})`,
          checked: true,
          prop: 'repurchaseAmountDollar'
        },
        {
          id: 4,
          text: `${'当月首购拨比'}(${isLocalSymbol()})`,
          checked: true,
          prop: 'fansAmountDollar'
        }
      ],
      creationTime: [],
      creationTime1: [],
      select: {

      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 50
      },
      addOrEdit: '',
      total: 0,
      dialogVisible: false,
      loading: false,
      tableData: {
        censusSummaryList: []
      },
      moren: '/settlementCenter/bonusCount',
      topList: [
        {
          name: '奖金计算',
          path: '/settlementCenter/bonusCount'
        }
      ],
      form: {
        name: ''
      },
      rules: {
        name: [{ required: true, message: '请输入规格类型', trigger: 'blur' }]
      },
      acList: [],
      verList: [],
      memberList: [],
      yieldList: [],
      yieldStatus: [],
      countryList: [],
      orderTypeList: [],
      operatorLoading: false
    }
  },
  mounted() {
    // 获取下拉
    // 获取列表
    this.getDataList()
  },
  computed: {
    ...mapGetters(['getUser'])
  },
  methods: {
    isLocalSymbol,
    isLocal,
    stateFormat,
    verifySelect() {
      const len = this.$refs.multipleTable.selection.length
      if (len === 0) {
        Message({ message: '请选择一条数据', type: 'warning' })
      } else if (len > 1) {
        Message({ message: '只能选择一条', type: 'warning' })
      } else {
        return true
      }
    },
    // 结算
    balance() {
      const verify = this.verifySelect()
      const time = this.$refs.multipleTable.selection[0].settleDate
      if (verify) {
        this.operatorLoading = true
        settleBonus({ 'settleDate': time }).then((res) => {
          if (res.code == 200) {
            Message({
              message: res.msg,
              type: 'success'
            })
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        }).finally(() => {
          this.operatorLoading = false
        })
      }
    },
    // 不公布
    publish1() {
      const verify = this.verifySelect()
      const time = this.$refs.multipleTable.selection[0].settleDate
      if (verify) {
        this.operatorLoading = true
        noPublishBonus({ 'settleDate': time }).then((res) => {
          if (res.code == 200) {
            Message({
              message: res.msg,
              type: 'success'
            })
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        }).finally(() => {
          this.operatorLoading = false
        })
      }
    },
    // 公布
    publish() {
      const verify = this.verifySelect()
      const time = this.$refs.multipleTable.selection[0].settleDate
      if (verify) {
        this.operatorLoading = true
        publishBonus({ 'settleDate': time }).then((res) => {
          if (res.code == 200) {
            Message({
              message: res.msg,
              type: 'success'
            })
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        }).finally(() => {
          this.operatorLoading = false
        })
      }
    },
    // 发放
    grant() {
      const verify = this.verifySelect()
      const time = this.$refs.multipleTable.selection[0].settleDate
      if (verify) {
        grantBonus({ 'settleDate': time }).then((res) => {
          if (res.code == 200) {
            Message({
              message: res.msg,
              type: 'success'
            })
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        }).finally(() => {
          this.operatorLoading = false
        })
      }
    },
    // 提现
    withdraw() {
      const verify = this.verifySelect()
      const time = this.$refs.multipleTable.selection[0].settleDate
      if (verify) {
        this.operatorLoading = true
        withdrawalBonus({ 'settleDate': time }).then((res) => {
          if (res.code == 200) {
            Message({
              message: res.msg,
              type: 'success'
            })
          } else {
            Message({
              message: res.msg,
              type: 'error'
            })
          }
        }).finally(() => {
          this.operatorLoading = false
        })
      }
    },
    // 展开折叠
    changeActive() {
      this.isActive = !this.isActive
    },
    reset() {
      this.select = {

      }
      // this.creationTime = ''
      this.creationTime = []
      this.getDataList()
    },
    getMenu(e, id) {
      if (e && id == 0) {
        this.menuList.forEach((item) => {
          this.$set(item, 'checked', true)
        })
      } else if (!e && id == 0) {
        this.menuList.forEach((item) => {
          this.$set(item, 'checked', false)
        })
      }
    },
    changeTime(val) {
      if (val) {
        this.select.startDate = val[0]
        this.select.endDate = val[1]
      }
    },
    // 点击修改
    toFixed(id) {
      this.addOrEdit = false
      this.dialogVisible = true
      this.$router.push({
        path: 'noticeList/details',
        query: {
          pkId: id
        }
      })
    },
    getSummaries(param) {
      const { columns, data } = param
      const sums = []
      columns.forEach((column, index) => {
        if (index === 0) {
          sums[index] = '小计' + '(￥)'
          return
        }
        if (index === 1) {
          sums[index] = ''
          return
        }
        const values = data.map((item) => Number(item[column.property]))
        if (!values.every((value) => isNaN(value))) {
          sums[index] = values.reduce((prev, curr) => {
            const value = Number(curr)
            if (!isNaN(value)) {
              return prev + curr
            } else {
              return prev
            }
          }, 0)
          // sums[index] += ' 元'
        } else {
          sums[index] = ''
        }
      })

      return sums
    },
    // 删除
    handleDelete(id) {
      this.$confirm('确认删除?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        api.classifyDel(id).then((res) => {
          this.getDataList()
        })
      })
    },
    onSubmit(formName) {
      this.$refs[formName].validate((valid) => {
        if (valid) {
          let url = ''
          if (this.addOrEdit == true) {
            url = classifySave
          } else {
            url = classifyUpdate
          }
          url(this.form).then((res) => {
            if (res.code == 200) {
              this.$message({
                message: res.msg,
                type: 'success'
              })
              this.dialogVisible = false
              // 充值数据
              this.$refs[formName].resetFields()
              // 获取列表
              this.getDataList()
            }
          })
        } else {
          return false
        }
      })
    },
    handleClose() {
      this.dialogVisible = false
      this.$refs['form'].clearValidate()
      this.$refs['form'].resetFields()
    },
    openDig() {
      this.$router.push({
        path: 'noticeList/details'
      })
    },
    getDataList() {
      this.loading = true
      if (this.select.period) {
        this.select.period = parseInt(this.select.period)
      }
      if (this.creationTime == '' || this.creationTime == null) {
        this.select.startDate = ''
        this.select.endDate = ''
      }
      Number(this.select)
      listPeriod(Object.assign({}, this.select), `?pageNum=${this.queryParams.pageNum}&pageSize=${this.queryParams.pageSize}`)
        .then((res) => {
          this.loading = false
          this.tableData.censusSummaryList = res.rows
          this.total = res.total
        })
    },
    handleSelectionChange(val) {},
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams
      this.$confirm('是否确认导出所有数据项?', '警告', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      })
        .then(function() {
          return api.exportClassIfy(queryParams)
        })
        .then((response) => {
          this.download(response)
        })
    },
    tableRowClassName({ row, rowIndex }) {
      if (rowIndex % 2 == 1) {
        return 'warning-row'
      } else if (rowIndex % 2 == 0) {
        return 'success-row'
      }
      return ''
    }
  }
}
</script>
<style scoped lang="scss">

::v-deep .el-range-editor.el-input__inner{
  width: 100%!important;
}
::v-deep .el-button{
  padding: 8px 20px;
}
::v-deep .el-date-editor .el-range__close-icon{
  margin-top: -10px;
}
::v-deep .el-date-editor .el-range-separator{
  margin-top: -10px;
}
::v-deep .el-date-editor .el-range__icon{
  margin-top: -10px;
}
::v-deep .el-input__inner{
  //height:28px;
  //line-height: 28px;
}
::v-deep .el-form-item__label{
  color: #333;
  font-weight: inherit;
}
::v-deep .el-table .warning-row {
  background: #f9f9f9;
}

::v-deep .el-table .success-row {
  background: #ffffff;
}
::v-deep .el-table thead {
  color: #000000;
}
::v-deep .el-select {
  width: 100%;
}
.uploadIcon ::v-deep .el-upload--picture-card {
  display: none !important; /* 上传按钮隐藏 */
}
.page {
  padding: 20px;
  background: #f9f9f9;
  font-size: 14px;
  .main {
    background: #f9f9f9;
    //border-radius: 8px;
    //box-shadow: 0px 2px 20px 0px rgba(238, 238, 238, 0.5);
    .maintop {
      display: flex;
      padding: 0 0;
      justify-content: space-between;
      align-items: center;
      .mainbtn {
        .thebtn1 {
          background: #3181e5;
          color: #ffffff;
        }
        .thebtn2 {
          background: #F3A900;
          color: #ffffff;
        }
      }
      .maintitle {
        font-size: 10px;
        font-family: MicrosoftYaHei;
        color: #999999;
      }
    }
  }
  .tem {
    display: flex;
    align-items: center;
    justify-content: center;
    img {
      width: 28px;
      height: 20px;
      margin-right: 3px;
    }
  }
  .isRed {
    color: #ed1d25;
  }
  .isGreen {
    color: #1ab62b;
  }
  .bgImg {
    width: 48px;
    height: 48px;
  }
}
.openClose {
  margin-right: 10px;
  color: #666666;
  text-align: center;
}
.kuang {
  padding: 5px 20px;
  background: rgba(255, 255, 255, 0);
  border-radius: 4px;
  border: 1px solid #cccccc;
  margin-right: 10px;
}
.heji {
  margin-top: 10px;
  .dis {
    display: flex;
    justify-content: right;
    padding: 5px 10px;
    font-size: 14px;
    color: #333333;
    :nth-child(1) {
      font-size: 14px;
      font-weight: bold;
      color: #333333;
      margin-right: 20px;
    }
  }
}
</style>
